;*************************************************************************
; PHONE LIST v1.0
; for USGARD 1.1
;
; by Doug Melton
;
; started     : 8/20/97
; last updated: 8/20/97
;
;*************************************************************************

#include usgard.h

.org 0
.db "Phone List v1.0 by DM",0

;*************************************************************************
;;;Variables
ProgStart       = TEXT_MEM      ; word
ProgEnd         = TEXT_MEM+2    ; word
TopLine         = TEXT_MEM+4    ; word
BotLine         = TEXT_MEM+6

TmpLine         = TEXT_MEM+8    ; 2 bytes
Timer           = TEXT_MEM+10   ; byte
;*************************************************************************
;main program

top:
	ld	hl, &phileName
	call	VAR_GET
;        jr      nc, fileFound
        ret     c                               ;file name not found

fileFound:
        ld      (ProgStart), hl
        ld      (TopLine), hl

        push    hl
        dec     hl
        ld      d, (hl)
        dec     hl
        ld      e, (hl)                         ;get len. of program
        pop     hl
        add     hl, de
        ld      (ProgEnd), hl                   

start:
        call    CLEARLCD                        ;DE gets cleared
        ld      (CURSOR_X), de
        ld      de, (TopLine)
        ld      b, 10
dispLoop:
        call    &disp1Line
        djnz    dispLoop
        ld      (BotLine), de

keyLoop:
        ld      a, (KEY_2)
	cp      K_UP
        jr      z, keyUp
	cp      K_DOWN
        jr      z, keyDown
        call    GET_KEY
        cp      K_LEFT
        jr      z, keyUp
        cp      K_RIGHT
        jr      z, keyDown
	cp      K_EXIT
        jr      nz, keyLoop
        ret     

keyUp:
        ld      hl, (ProgStart)
        ld      de, (TopLine)
        call    CP_HL_DE
        jr      z, keyLoop                      ;already at top

        ld      de, $FFBF
        ld      hl, $FF5F
        ld      bc, 54*16
        lddr                                    ;move lines down

        ld      hl, VIDEO_MEM+16
        ld      bc, 5*16-1
        call    OTH_CLEAR                       ;erase top line

        ld      hl, (BotLine)
        dec     hl
        ld      a, $D6
        cpdr
        inc     hl
        ld      (BotLine), hl

        ld      hl, (TopLine)
        dec     hl
        cpdr
        inc     hl

        ld      de, (ProgStart)
        call    CP_HL_DE
        jr      nc, up2                         ;went back too far in mem.
        ex      de, hl

up2:
        ld      (TopLine), hl

        ld      de, $0000
        ld      (CURSOR_X), de
        ex      de, hl
        call    &disp1Line

up2bottom:
        jr      keyLoop

keyDown:
        ld      hl, (ProgEnd)
        ld      de, (BotLine)
        call    CP_HL_DE
        jr      z, keyLoop                      ;already at bottom

        ld      de, VIDEO_MEM
        ld      hl, VIDEO_MEM+96
        ld      bc, 54*16
        ldir                                    ;move lines up

        ld      hl, VIDEO_MEM+880
        ld      bc, 5*16-1
        call    OTH_CLEAR                       ;erase top line

        ld      hl, (TopLine)
        inc     hl
        ld      a, $D6
        cpir
        dec     hl
        ld      (TopLine), hl

        ld      hl, $3600
	ld      (CURSOR_X), hl
        ld      de, (BotLine)
        call    &disp1Line
        ld      (BotLine), de

        jr      up2bottom


;*************************************************************************
;disp1Line - display 1 program line
;parameters:    CURSOR_X and CURSOR_Y set
;               de - pointer to start of line (it should be the n.l. char)
;output:        CURSOR_X = 1, CURSOR_Y = CURSOR_Y+6
;               a, de, hl destroyed 

disp1Line:
	inc	de

        ld      hl, (ProgEnd)
        call    CP_HL_DE
        ret     z                               ;return if bottom of program

        ld      a, (de)
newLineChar:
        cp      $D6                             ;check for newline char.
        jr      nz, yesACChar

	ld      a, (CURSOR_Y)
	add     a, 6
        ld      (CURSOR_Y), a
	ld      a, 1
        ld      (CURSOR_X), a                   ;move to beg. of next line
        ret

yesACChar:
        cp      '#'
        jr      nz, noACChar

        ld      a, 80
        ld      (CURSOR_X), a                   ;do a "tab"
        jr      disp1Line

noACChar:
        cp      $3A                             ;check for : char.
        jr      nz, lineCont

        ld      a, 96
        ld      (CURSOR_X), a                   ;do a "tab"
        jr      disp1Line

lineCont:
        ld      (TmpLine), a

        ld      a, (CURSOR_X)
        cp      128-3
        jr      nc, disp1Line                   ;char is off edge of screen

        push    de
        ld      hl, TmpLine
	call    D_ZM_STR
        pop     de

        jr      disp1Line

;*************************************************************************
phileName: .db "pl",0

.end

